Index: /trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 657)
+++ /trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 658)
@@ -1885,5 +1129,4 @@
 
       nz3 = nlayermx*2
-      szadeg = zenit*180./3.141592
       do i=1,nlayermx
          xx = ( radio + iz(i) ) * 1.e5
@@ -1911,4 +1154,5 @@
          Hno2  = xx / mmol(igcm_no2)
       endif
+      ! first loop in altitude : initialisation
       do i=nlayermx,1,-1
          !Column initialisation
@@ -1945,4 +1189,7 @@
             no2x(i)  = rm(i,i_no2)
          endif
+      enddo
+      ! second loop in altitude : column calculations
+      do i=nlayermx,1,-1
          !Routine to calculate the geometrical length of each layer
          call espesor_optico_A(ig,i,zenit,iz(i),nz3,iz,esp,ilayesp,
@@ -1971,5 +1218,5 @@
                !Top layer
                if(jj.eq.nlayermx) then
-                  if(szadeg.le.60.) then 
+                  if(zenit.le.60.) then 
                      o3pcolx(i)=o3pcolx(i)+o3px(nlayermx)*Ho3p*esp(j)
      $                    *1.e-5
@@ -2003,5 +1250,5 @@
      $                       *1.e-5
                      endif
-                  else if(szadeg.gt.60.) then
+                  else if(zenit.gt.60.) then
                      espco2 =sqrt((rcmnz+Hco2)**2 -rcmmini**2) - esp(j)
                      espo2  = sqrt((rcmnz+Ho2)**2 -rcmmini**2) - esp(j)
@@ -2040,5 +1287,5 @@
                         no2colx(i) = no2colx(i) + espno2*no2x(nlayermx)
                      endif
-                  endif !Of if szadeg.lt.60
+                  endif !Of if zenit.lt.60
                !Other layers
                else 
@@ -2086,5 +1333,6 @@
 c**********************************************************************
 c**********************************************************************
-      subroutine interpfast(escout,p,nlayer,escin,pin,nl,limdown,limup)
+
+      subroutine interfast(wm,wp,nm,p,nlayer,pin,nl,limdown,limup)
 C
 C subroutine to perform linear interpolation in pressure from 1D profile 
@@ -2092,28 +1340,29 @@
 C escout(nlayer) on pressure grid p(nlayer).
 C
-      real escout(nlayer),p(nlayer)
-      real escin(nl),pin(nl),wm,wp
-      real limup,limdown
-      integer nl,nlayer,n1,n,nm,np
-      nm=1
-      do 5 n1=1,nlayer
+      real*8 wm(nlayer),wp(nlayer),p(nlayer)
+      integer nm(nlayer)
+      real*8 pin(nl)
+      real*8 limup,limdown
+      integer nl,nlayer,n1,n,np,nini
+      nini=1
+      do n1=1,nlayer
          if(p(n1) .gt. limup .or. p(n1) .lt. limdown) then
-            escout(n1) = 0.0
+            wm(n1) = 0.d0
+            wp(n1) = 0.d0
          else
-            do n = nm,nl-1
+            do n = nini,nl-1
                if (p(n1).ge.pin(n).and.p(n1).le.pin(n+1)) then
-                  nm=n
+                  nm(n1)=n
                   np=n+1
-                  wm=abs(pin(nm)-p(n1))/(pin(np)-pin(nm))
-                  wp=1.0 - wm
-                  goto 33
+                  wm(n1)=abs(pin(n)-p(n1))/(pin(np)-pin(n))
+                  wp(n1)=1.d0 - wm(n1)
+                  nini = n
+                  exit
                endif
             enddo
- 33         escout(n1) = escin(np)*wm + escin(nm)*wp
          endif
-    5 continue
+      enddo
       return
       end
-
 
 
Index: /trunk/LMDZ.MARS/libf/aeronomars/moldiff.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/moldiff.F	(revision 657)
+++ /trunk/LMDZ.MARS/libf/aeronomars/moldiff.F	(revision 658)
@@ -279,9 +279,9 @@
 c Inverting the alfa matrix
 c
-        call ludcmp(alf,ncompmoldiff-1,ncompmoldiff-1,indx,d,ierr)
+        call ludcmp_sp(alf,ncompmoldiff-1,ncompmoldiff-1,indx,d,ierr)
 
 c       TEMPORAIRE *****************************
         if (ierr.ne.0) then
-            write(*,*) 'In moldiff: Problem in LUDCMP with matrix alf'
+            write(*,*)'In moldiff: Problem in LUDCMP_SP with matrix alf'
             write(*,*) 'Singular matrix ?'
 c           write(*,*) 'Matrix alf = ', alf
@@ -294,5 +294,5 @@
 c       *******************************************
         do n=1,ncompmoldiff-1
-          call lubksb(alf,ncompmoldiff-1,ncompmoldiff-1,indx,y(1,n))
+          call lubksb_sp(alf,ncompmoldiff-1,ncompmoldiff-1,indx,y(1,n))
           do nn=1,ncompmoldiff-1
             alfinv(l,nn,n)=y(nn,n)/hh
@@ -415,5 +415,5 @@
         btri(1)=btri(1)+atri(1)
 
-        call tridag(atri,btri,ctri,rtri,qtri,nz-2)
+        call tridag_sp(atri,btri,ctri,rtri,qtri,nz-2)
 
         do l=2,nz-1
@@ -464,10 +464,10 @@
 c    ********************************************************************
  
-      subroutine tridag(a,b,c,r,u,n)
-      parameter (nmax=100)
+      subroutine tridag_sp(a,b,c,r,u,n)
+c      parameter (nmax=100)
 c      dimension gam(nmax),a(n),b(n),c(n),r(n),u(n)
-      real gam(nmax),a(n),b(n),c(n),r(n),u(n)
+      real gam(n),a(n),b(n),c(n),r(n),u(n)
       if(b(1).eq.0.)then
-        stop 'tridag: error: b(1)=0 !!! '
+        stop 'tridag_sp: error: b(1)=0 !!! '
       endif
       bet=b(1)
@@ -477,5 +477,5 @@
         bet=b(j)-a(j)*gam(j)
         if(bet.eq.0.) then
-          stop 'tridag: error: bet=0 !!! '
+          stop 'tridag_sp: error: bet=0 !!! '
         endif
         u(j)=(r(j)-a(j)*u(j-1))/bet
@@ -491,5 +491,5 @@
 c    ********************************************************************
 
-      SUBROUTINE LUBKSB(A,N,NP,INDX,B)
+      SUBROUTINE LUBKSB_SP(A,N,NP,INDX,B)
 
       implicit none
@@ -530,5 +530,5 @@
 c    ********************************************************************
 
-      SUBROUTINE LUDCMP(A,N,NP,INDX,D,ierr)
+      SUBROUTINE LUDCMP_SP(A,N,NP,INDX,D,ierr)
 
       implicit none
@@ -550,5 +550,5 @@
 11      CONTINUE
         IF (AAMAX.EQ.0.) then
-            write(*,*) 'In moldiff: Problem in LUDCMP with matrix A'
+            write(*,*) 'In moldiff: Problem in LUDCMP_SP with matrix A'
             write(*,*) 'Singular matrix ?'
 c           write(*,*) 'Matrix A = ', A
Index: /trunk/LMDZ.MARS/libf/aeronomars/moldiff_red.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/moldiff_red.F90	(revision 657)
+++ /trunk/LMDZ.MARS/libf/aeronomars/moldiff_red.F90	(revision 658)
@@ -726,7 +726,7 @@
 
       subroutine tridag(a,b,c,r,u,n)
-      parameter (nmax=4000)
+!      parameter (nmax=4000)
 !      dimension gam(nmax),a(n),b(n),c(n),r(n),u(n)
-      real*8 gam(nmax),a(n),b(n),c(n),r(n),u(n)
+      real*8 gam(n),a(n),b(n),c(n),r(n),u(n)
       if(b(1).eq.0.)then
         stop 'tridag: error: b(1)=0 !!! '
Index: /trunk/LMDZ.MARS/libf/aeronomars/param_read.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/param_read.F	(revision 657)
+++ /trunk/LMDZ.MARS/libf/aeronomars/param_read.F	(revision 658)
@@ -95,5 +95,5 @@
       IF (ierr.NE.0) THEN 
        write(*,*)'cant find directory EUVDAT and content coln.dat'
-       write(*,*)'(in aeronomars/param_read_iono.F)'
+       write(*,*)'(in aeronomars/param_read.F)'
        write(*,*)'It should be in :', datafile,'/'
        write(*,*)'1) You can change this directory address in '
@@ -181,106 +181,106 @@
 
       do i=nz2,1,-1
-         read(220,*) (jabsifotsintpar(j,2,i),j=1,16)
-      end do
-      
-      do i=nz2,1,-1
-         read(230,*) (jabsifotsintpar(j,3,i),j=1,16)
-      end do
-
-      do i=nz2,1,-1
-         read(240,*) (jabsifotsintpar(j,1,i),j=1,16)
-      end do
-
-      do i=nz2,1,-1
-         read(250,*) (jabsifotsintpar(j,2,i),j=17,24)
-      end do
-
-
-      do i=nz2,1,-1
-         read(260,*) (jabsifotsintpar(j,2,i),j=25,31)
-      end do
-
-      do i=nz2,1,-1
-         read(270,*) (jabsifotsintpar(j,1,i),j=17,24)
-      end do
-
-      do i=nz2,1,-1
-         read(280,*) (jabsifotsintpar(j,1,i),j=25,31)
-      end do
-
-      do i=nz2,1,-1
-         read(290,*) jabsifotsintpar(32,1,i)
-      end do
-
-      do i=nz2,1,-1
-         read(300,*) (jabsifotsintpar(j,2,i),j=32,34)
-      end do
-
-      do i=nz2,1,-1
-         read(160,*) (jabsifotsintpar(j,5,i),j=1,15)
-      end do
-
-      do i=nz2,1,-1
-         read(150,*) (jabsifotsintpar(j,4,i),j=25,31)
-      end do
-
-      do i=nz2,1,-1
-         read(170,*) (jabsifotsintpar(j,6,i),j=25,35)
-      end do
-
-      do i=nz2,1,-1
-         read(180,*) (jabsifotsintpar(j,7,i),j=34,36)
-      end do
-
-      do i=nz2,1,-1
-         read(390,*) (jabsifotsintpar(j,8,i),j=2,16)
-      enddo
-
-      do i=nz2,1,-1
-         read(400,*) (jabsifotsintpar(j,8,i),j=17,24)
-      enddo
-
-      do i=nz2,1,-1
-         read(410,*) (jabsifotsintpar(j,9,i),j=1,16)
-      enddo
-
-      do i=nz2,1,-1
-         read(420,*) (jabsifotsintpar(j,10,i),j=2,16)
-      enddo
-
-      do i=nz2,1,-1
-         read(430,*) (jabsifotsintpar(j,10,i),j=17,24)
-      enddo
-
-      do i=nz2,1,-1
-         read(440,*) (jabsifotsintpar(j,10,i),j=25,32)
-      enddo
-
-      do i=nz2,1,-1
-         read(450,*) (jabsifotsintpar(j,11,i),j=2,16)
-      enddo
-
-      do i=nz2,1,-1
-         read(460,*) (jabsifotsintpar(j,11,i),j=17,24)
-      enddo
-
-      do i=nz2,1,-1
-         read(470,*) (jabsifotsintpar(j,11,i),j=25,29)
-      enddo
-      
-      do i=nz2,1,-1
-         read(480,*) (jabsifotsintpar(j,12,i),j=2,16)
-      enddo
-
-      do i=nz2,1,-1
-         read(490,*) (jabsifotsintpar(j,13,i),j=2,16)
-      enddo
-      
-      do i=nz2,1,-1
-         read(500,*) (jabsifotsintpar(j,13,i),j=17,24)
-      enddo
-      
-      do i=nz2,1,-1
-         read(510,*) (jabsifotsintpar(j,13,i),j=25,36)
+         read(220,*) (jabsifotsintpar(i,2,j),j=1,16)
+      end do
+      
+      do i=nz2,1,-1
+         read(230,*) (jabsifotsintpar(i,3,j),j=1,16)
+      end do
+
+      do i=nz2,1,-1
+         read(240,*) (jabsifotsintpar(i,1,j),j=1,16)
+      end do
+
+      do i=nz2,1,-1
+         read(250,*) (jabsifotsintpar(i,2,j),j=17,24)
+      end do
+
+
+      do i=nz2,1,-1
+         read(260,*) (jabsifotsintpar(i,2,j),j=25,31)
+      end do
+
+      do i=nz2,1,-1
+         read(270,*) (jabsifotsintpar(i,1,j),j=17,24)
+      end do
+
+      do i=nz2,1,-1
+         read(280,*) (jabsifotsintpar(i,1,j),j=25,31)
+      end do
+
+      do i=nz2,1,-1
+         read(290,*) jabsifotsintpar(i,1,32)
+      end do
+
+      do i=nz2,1,-1
+         read(300,*) (jabsifotsintpar(i,2,j),j=32,34)
+      end do
+
+      do i=nz2,1,-1
+         read(160,*) (jabsifotsintpar(i,5,j),j=1,15)
+      end do
+
+      do i=nz2,1,-1
+         read(150,*) (jabsifotsintpar(i,4,j),j=25,31)
+      end do
+
+      do i=nz2,1,-1
+         read(170,*) (jabsifotsintpar(i,6,j),j=25,35)
+      end do
+
+      do i=nz2,1,-1
+         read(180,*) (jabsifotsintpar(i,7,j),j=34,36)
+      end do
+
+      do i=nz2,1,-1
+         read(390,*) (jabsifotsintpar(i,8,j),j=2,16)
+      enddo
+
+      do i=nz2,1,-1
+         read(400,*) (jabsifotsintpar(i,8,j),j=17,24)
+      enddo
+
+      do i=nz2,1,-1
+         read(410,*) (jabsifotsintpar(i,9,j),j=1,16)
+      enddo
+
+      do i=nz2,1,-1
+         read(420,*) (jabsifotsintpar(i,10,j),j=2,16)
+      enddo
+
+      do i=nz2,1,-1
+         read(430,*) (jabsifotsintpar(i,10,j),j=17,24)
+      enddo
+
+      do i=nz2,1,-1
+         read(440,*) (jabsifotsintpar(i,10,j),j=25,32)
+      enddo
+
+      do i=nz2,1,-1
+         read(450,*) (jabsifotsintpar(i,11,j),j=2,16)
+      enddo
+
+      do i=nz2,1,-1
+         read(460,*) (jabsifotsintpar(i,11,j),j=17,24)
+      enddo
+
+      do i=nz2,1,-1
+         read(470,*) (jabsifotsintpar(i,11,j),j=25,29)
+      enddo
+      
+      do i=nz2,1,-1
+         read(480,*) (jabsifotsintpar(i,12,j),j=2,16)
+      enddo
+
+      do i=nz2,1,-1
+         read(490,*) (jabsifotsintpar(i,13,j),j=2,16)
+      enddo
+      
+      do i=nz2,1,-1
+         read(500,*) (jabsifotsintpar(i,13,j),j=17,24)
+      enddo
+      
+      do i=nz2,1,-1
+         read(510,*) (jabsifotsintpar(i,13,j),j=25,36)
       enddo
 
Index: /trunk/LMDZ.MARS/libf/aeronomars/param_v4.h
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/param_v4.h	(revision 657)
+++ /trunk/LMDZ.MARS/libf/aeronomars/param_v4.h	(revision 658)
@@ -29,5 +29,5 @@
       real fluxtop(ninter)
       real freccen(ninter)          !representative wavelenght
-      real jabsifotsintpar(ninter,nabs,nz2)
+      real jabsifotsintpar(nz2,nabs,ninter)
 
 
